unit edtDBScrollBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, 
  StdCtrls, Buttons, ExtCtrls, 
  wwDBEdit, 
  wwDatSrc, 
  wwRiched, 
  Wwdbdlg, 
  wwdblook, 
  Wwdotdot, 
  Wwdbspin, 
  Wwdbcomb, 
  Mask, 
  dbctrls;
type
  TfrmEdtDBScrollBox = class(TForm)
      Panel1         : TPanel;
      lbxDBScrollBox : TListBox;
      rgpChangeTo    : TRadioGroup;
      btnOk          : TBitBtn;
      btnCancel      : TBitBtn;
      procedure lbxDBScrollBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
      procedure FormShow(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
    private
      { Private declarations }
      FBitMap : TBitMap;
    public
      { Public declarations }
      procedure AddItem (Control : TControl);
  end;

var
  frmEdtDBScrollBox : TfrmEdtDBScrollBox;

implementation

{$R *.DFM}

procedure TfrmEdtDBScrollBox.AddItem (Control : TControl);
var
  displayName : string;
begin
  DisplayName := Control.Name;

  FBitmap := TBitmap.Create;

  if Control is TwwDBEdit           then FBitMap.LoadFromResourceName(HInstance,'TWWDBEDIT');
  if Control is TwwDBComboBox       then FBitMap.LoadFromResourceName(HInstance,'TWWDBCOMBOBOX');
  if Control is TwwDBSpinEdit       then FBitMap.LoadFromResourceName(HInstance,'TWWDBSPINEDIT');
  if Control is TwwDBComboDlg       then FBitMap.LoadFromResourceName(HInstance,'TWWDBCOMBODLG');
  if Control is TwwDBLookUpCombo    then FBitMap.LoadFromResourceName(HInstance,'TWWDBLOOKUPCOMBO');
  if Control is TwwDBLookUpComboDlg then FBitMap.LoadFromResourceName(HInstance,'TWWDBLOOKUPCOMBODLG');
  if Control is TwwDBRichEdit       then FBitMap.LoadFromResourceName(HInstance,'TWWDBRICHEDIT');
  if Control is TDBImage            then FBitMap.LoadFromResourceName(HInstance,'TDBIMAGE');
  if Control is TDBMemo             then FBitMap.LoadFromResourceName(HInstance,'TDBMEMO');
  if Control is TDBCheckBox         then FBitMap.LoadFromResourceName(HInstance,'TDBCHECKBOX');

  lbxDBScrollBox.ItemHeight := FBitmap.Height + 1;
  lbxDBScrollBox.Items.AddObject(DisplayName, TObject(FBitMap));

end;

procedure TfrmEdtDBScrollBox.lbxDBScrollBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);

var
  Bitmap : TBitmap;      { temporary variable for the items bitmap }
  Offset : Integer;      { text offset width }
begin
  with (Control as TListBox).Canvas do  { draw on control canvas, not on the form }
    begin
      FillRect(Rect);       { clear the rectangle }
      Offset := 2;          { provide default offset }
      Bitmap := TBitmap((Control as TListBox).Items.Objects[Index]);  { get the bitmap }

      if Bitmap <> nil then
        begin
          BrushCopy(Bounds(Rect.Left + 2, Rect.Top, Bitmap.Width, Bitmap.Height),
          Bitmap, Bounds(0, 0, Bitmap.Width, Bitmap.Height), clRed);  {render bitmap}
          Offset := Bitmap.width + 6;    { add four pixels between bitmap and text}
        end;
      TextOut(Rect.Left + Offset, Rect.Top, (Control as TListBox).Items[Index])  { display the text }
    end;

end;

procedure TfrmEdtDBScrollBox.FormShow(Sender: TObject);
begin
  FBitmap := TBitmap.Create;
end;

procedure TfrmEdtDBScrollBox.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FBitmap.Free;
end;

end.
